package com.logicbig.example;


import com.logicbig.example.bean.UserRegistrationBean;
import com.logicbig.example.bean.UserRegistrationBeanImpl;
import com.logicbig.example.bean.UserRegistrationValidator;
import com.logicbig.example.service.RegistrationService;
import com.logicbig.example.service.RegistrationServiceImpl;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Scope;


@Configuration
public class Config {

    @Bean
    public UserRegistrationValidator validator () {
        return new UserRegistrationValidator();
    }

    @Bean
    public RegistrationService registrationService () {
        return new RegistrationServiceImpl();
    }

    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    @Bean
    public UserRegistrationBean userRegistrationBean () {
        return new UserRegistrationBeanImpl();
    }
}